#include <bits/stdc++.h>
#define int long long
using namespace std;
int v[2001];
int dp[2001][2001];
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,k,sum=0;
    cin>>n>>k;
    for(int i=0;i<n;i++)
    {
        cin>>v[i];
    }
    dp[0][1]=v[0];
    for(int i=0;i<n;i++)
    {
        sum=(sum | v[i]);
        dp[i][1]=max(dp[i][1],sum);
        for(int j=2;j<=i+1;j++)
        {
            int sum1=0;
            for(int u=i;u>=j-1;u--)
            {
                sum1=(sum1 | v[u]);
                int val=(dp[u-1][j-1] & sum1);
                dp[i][j]=max(dp[i][j],val);
            }
        }
    }
    cout<<dp[n-1][k];
    return 0;
}
